<template>
  <div id="home">
    <v-app dark>
      <div class="overflow-hidden bg-gray-100">
        <div
          id="mainSidebar"
          class="sidebar flex flex-col justify-between bg-red border relative"
          :class="drawer == true ? 'open' : ''"
        >
          <div
            class="bg-white w-4 h-10 flex items-center toggle-sidebar-desktop"
            style="top: 8%; border-radius: 0px 8px 8px 0px; transition all 0.4s"
            :class="drawer == true ? 'toggle-open' : 'toggle-close'"
          >
            <button
              @click="toggleSideBar()"
              class="flex items-center justify-center cursor-pointer"
            >
              <svg
                v-if="drawer == true"
                xmlns="http://www.w3.org/2000/svg"
                fill="none"
                viewBox="0 0 24 24"
                stroke-width="1.5"
                stroke="currentColor"
                class="w-4 h-5"
              >
                <path
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  d="M15.75 19.5L8.25 12l7.5-7.5"
                />
              </svg>
              <svg
                v-else
                xmlns="http://www.w3.org/2000/svg"
                viewBox="0 0 24 24"
                fill="currentColor"
                class="w-4 h-5"
              >
                <path
                  fill-rule="evenodd"
                  d="M16.28 11.47a.75.75 0 010 1.06l-7.5 7.5a.75.75 0 01-1.06-1.06L14.69 12 7.72 5.03a.75.75 0 011.06-1.06l7.5 7.5z"
                  clip-rule="evenodd"
                />
              </svg>
            </button>
          </div>
          <div
            class="relative"
            :style="drawer == true ? '' : 'side-bar-close-desktop'"
          >
            <div @click="onClickCloseSideBarMbMainPage()">
              <nuxt-link to="/seller/dashboard">
                <div class="logo-details flex justify-center">
                  <div
                    v-if="screenWidth > 768"
                    class="items-center flex justify-center min-h-[30px]"
                  >
                    <div class="min-w-[30px] max-w-[30px] h-[30px]">
                      <img
                        src="~/assets/images/logo-not-text.png"
                        alt=""
                        class="w-full h-full"
                      />
                    </div>

                    <h1
                      class="text-[#37537B] logo_name min-w-[75px] text-xl font-extrabold pl-1 logo-name"
                      style="font-family: Plus Jakarta Sans"
                    >
                      Master
                    </h1>
                  </div>
                  <div
                    v-else
                    class="text-center flex items-center justify-between px-1"
                  >
                    <div class="flex items-center">
                      <div class="min-w-[30px] max-w-[30px] h-[30px]">
                        <img
                          src="~/assets/images/logo-not-text.png"
                          alt=""
                          class="w-full h-full"
                        />
                      </div>
                      <div class="logo_name">
                        <img
                          src="~/assets/images/Black.png"
                          alt=""
                          class="w-full h-full"
                        />
                      </div>
                    </div>
                    <button class="toggle-sidebar-mb" @click="drawer = !drawer">
                      <svg
                        xmlns="http://www.w3.org/2000/svg"
                        width="24"
                        height="24"
                        viewBox="0 0 24 24"
                        fill="none"
                      >
                        <path
                          d="M3 6H21V8H3V6ZM3 11H21V13H3V11ZM3 16H21V18H3V16Z"
                          fill="black"
                        />
                      </svg>
                    </button>
                  </div>
                </div>
              </nuxt-link>
            </div>

            <ul class="nav-list">
              <li class="sm:px-2 px-1 py-1">
                <div @click="onClickCloseSideBarMb()">
                  <nuxt-link
                    v-if="drawer == true"
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/master/manage-user"
                    style="transition: 0.4s"
                  >
                    <svg
                      xmlns="http://www.w3.org/2000/svg"
                      fill="none"
                      viewBox="0 0 24 24"
                      stroke-width="1.5"
                      stroke="currentColor"
                      class="icon-nav-link svg-icon"
                    >
                      <path
                        stroke-linecap="round"
                        stroke-linejoin="round"
                        d="M18 18.72a9.094 9.094 0 003.741-.479 3 3 0 00-4.682-2.72m.94 3.198l.001.031c0 .225-.012.447-.037.666A11.944 11.944 0 0112 21c-2.17 0-4.207-.576-5.963-1.584A6.062 6.062 0 016 18.719m12 0a5.971 5.971 0 00-.941-3.197m0 0A5.995 5.995 0 0012 12.75a5.995 5.995 0 00-5.058 2.772m0 0a3 3 0 00-4.681 2.72 8.986 8.986 0 003.74.477m.94-3.197a5.971 5.971 0 00-.94 3.197M15 6.75a3 3 0 11-6 0 3 3 0 016 0zm6 3a2.25 2.25 0 11-4.5 0 2.25 2.25 0 014.5 0zm-13.5 0a2.25 2.25 0 11-4.5 0 2.25 2.25 0 014.5 0z"
                      />
                    </svg>

                    <span class="links_name">Manage Admin</span>
                  </nuxt-link>
                  <nuxt-link
                    v-else
                    class="p-2 items-sidebar hover:rounded-lg"
                    to="/admin/dashboard"
                    style="transition: 0.4s"
                  >
                    <svg
                      xmlns="http://www.w3.org/2000/svg"
                      fill="none"
                      viewBox="0 0 24 24"
                      stroke-width="1.5"
                      stroke="currentColor"
                      class="icon-nav-link svg-icon"
                    >
                      <path
                        stroke-linecap="round"
                        stroke-linejoin="round"
                        d="M18 18.72a9.094 9.094 0 003.741-.479 3 3 0 00-4.682-2.72m.94 3.198l.001.031c0 .225-.012.447-.037.666A11.944 11.944 0 0112 21c-2.17 0-4.207-.576-5.963-1.584A6.062 6.062 0 016 18.719m12 0a5.971 5.971 0 00-.941-3.197m0 0A5.995 5.995 0 0012 12.75a5.995 5.995 0 00-5.058 2.772m0 0a3 3 0 00-4.681 2.72 8.986 8.986 0 003.74.477m.94-3.197a5.971 5.971 0 00-.94 3.197M15 6.75a3 3 0 11-6 0 3 3 0 016 0zm6 3a2.25 2.25 0 11-4.5 0 2.25 2.25 0 014.5 0zm-13.5 0a2.25 2.25 0 11-4.5 0 2.25 2.25 0 014.5 0z"
                      />
                    </svg>
                  </nuxt-link>
                </div>
              </li>
            </ul>
          </div>

          <div
            class="px-0 flex flex-col justify-end items-center py-4"
            :style="
              drawer == true
                ? 'max-width: 215px; min-width: 200px;'
                : 'max-width: 50px; min-width: 45px; max-height:68px'
            "
            style="transition: all 0.2s"
          >
            <v-menu
              class="w-full !rounded-md"
              content-class="menu-account"
              offset-y
              top
              nudge-top="10px"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-chip
                  v-bind="attrs"
                  v-on="on"
                  class="w-full chip-menu"
                  style="height: 52px"
                  :class="drawer == false ? 'justify-center flex px-0' : ''"
                  color="#F5F7F9"
                >
                  <div class="flex align-center">
                    <v-icon size="32" color="#95a5a6">
                      mdi-account-circle
                    </v-icon>

                    <div v-if="drawer == true" class="ml-2">
                      <p class="mb-0 text-sm font-semibold text-content-main">
                        Master
                      </p>
                      <p class="mb-0 text-sm text-content-subtitle">
                        {{
                          userInfo &&
                          userInfo.email &&
                          userInfo.email.length > 15
                            ? userInfo.email.slice(0, 18) + "..."
                            : userInfo.email
                        }}
                      </p>
                    </div>
                  </div>
                </v-chip>
              </template>
              <div class="white">
                <div
                  class="list-hover c-pointer px-3 py-1"
                  @click="$router.push('/master/account-setting')"
                >
                  <p
                    class="mb-0 fsize-14-400 !p-2"
                    style="color: rgba(0, 0, 0, 0.87)"
                  >
                    Account Setting
                  </p>
                </div>
                <v-divider></v-divider>
                <div class="list-hover c-pointer px-3 py-1" @click="onLogout()">
                  <p
                    class="mb-0 fsize-14-400 !p-2"
                    style="color: rgba(0, 0, 0, 0.87)"
                  >
                    Logout
                  </p>
                </div>
              </div>
            </v-menu>
          </div>
        </div>
        <v-main
          class="home-section overflow-hidden dark:!bg-bg-main-dark h-full"
        >
          <div id="header" class="bg-white py-3 fixed top-0 w-full z-20">
            <button class="absolute left-2" @click="drawer = !drawer">
              <svg
                xmlns="http://www.w3.org/2000/svg"
                width="24"
                height="24"
                viewBox="0 0 24 24"
                fill="none"
              >
                <path
                  d="M3 6H21V8H3V6ZM3 11H21V13H3V11ZM3 16H21V18H3V16Z"
                  fill="black"
                />
              </svg>
            </button>
            <nuxt-link to="/admin/dashboard">
              <div class="flex">
                <div class="min-w-[30px] max-w-[30px] h-[30px]">
                  <img
                    src="~/assets/images/logo-not-text.png"
                    alt=""
                    class="w-full h-full"
                  />
                </div>

                <h1
                  class="text-[#37537B] logo_name min-w-[75px] text-xl font-extrabold pl-1 logo-name"
                  style="font-family: Plus Jakarta Sans"
                >
                  Master
                </h1>
              </div>
            </nuxt-link>
          </div>
          <div
            v-show="drawer == true"
            v-if="screenWidth < 768"
            @click="onClickCloseSideBarMbMainPage()"
            class="overlay-bg"
          ></div>
          <div
            @click="onClickCloseSideBarMbMainPage()"
            class="py-5 lg:!px-6 !px-4 mx-auto max-w-[1440px] h-full md:mt-0 mt-[56px]"
          >
            <LoadingComponent v-show="loadingFullPage" />
            <div v-show="!loadingFullPage" class="pb-6">
              <Nuxt />
            </div>
          </div>
        </v-main>
      </div>
    </v-app>
  </div>
</template>

<script lang="ts">
import {
  Component,
  getModule,
  Prop,
  Vue,
  Watch,
} from "nuxt-property-decorator";
import { api } from "~/common/constaint";
import UserModule from "~/store/user";
import { redirectPage } from "~/utils/apiHanlers";

@Component({
  components: {
    LoadingComponent: () => import("@/components/Utils/Loading/index.vue"),
  },
})
export default class DefaultLayout extends Vue {
  drawer = true;
  screenWidth = 0;
  openListDropdown = false;
  adminProduct = getModule(UserModule, this.$store);

  listSetting = [
    { title: "General", link: "/admin/settings/general" },
    { title: "Payment Methods", link: "/admin/settings/payment-method" },
    { title: "Domains", link: "/admin/settings/domain" },
    { title: "Emails", link: "/admin/settings/emails" },
    { title: "Abandon Mail", link: "/admin/settings/abandon" },
    { title: "Storefront", link: "/admin/settings/storefront" },
    { title: "Shipping", link: "/admin/shipping" },
  ];

  listAnalytics = [
    { title: "Sessions", link: "/seller/analytics/sessions" },
    { title: "Revenue", link: "/seller/analytics/revenue" },
  ];
  get href() {
    const path = this.$route.path;
    return path || "";
  }
  onClickCloseSideBarMb() {
    if (this.screenWidth < 768) {
      this.drawer = !this.drawer;
    }
  }
  get isActiveListGroupShop() {
    const route = this.$route.path;
    return route.includes("/settings") ? true : false;
  }

  get isActiveListGroupAnalytics() {
    const route = this.$route.path;
    return route.includes("/analytics") ? true : false;
  }

  openDropdown() {
    this.drawer = true;
    this.openListDropdown = true;
  }

  onClickCloseSideBarMbMainPage() {
    if (this.screenWidth < 768) {
      this.drawer = false;
    }
  }
  isActiveListItemSetting(link: string) {
    const route = this.$route.path;
    if (route.includes(link)) {
      return route;
    }
    return "";
  }

  get loadingFullPage() {
    return this.$store.state.adminProduct.loadingFullPage;
  }

  created() {
    if (
      //@ts-ignore
      this.$vuetify.breakpoint.name !== "lg" &&
      //@ts-ignore
      this.$vuetify.breakpoint.name !== "xl"
    ) {
      this.drawer = false;
    } else {
      this.drawer = true;
    }
  }

  get isActiveListGroupSetting() {
    const route = this.$route.path;
    return route.includes("/settings") ? true : false;
  }
  isActiveListItem(link: string) {
    const route = this.$route.path;
    if (route.includes(link)) {
      return route;
    }
    return "";
  }
  mounted() {
    this.updateScreenWidth();
    this.onGetMe();
  }
  onScreenResize() {
    window.addEventListener("resize", () => {
      this.updateScreenWidth();
    });
  }
  async onGetMe() {
    await this.$store.dispatch("user/onGetMe", { ctx: this });
  }

  get userInfo() {
    return this.$store.state.user.userInfo;
  }

  get convertImage() {
    const siteInfo = this.$store.state.setting.siteInfo;
    if (siteInfo && siteInfo.logo) {
      return `${api}/${siteInfo.logo}`;
    }
    return "";
  }

  async onLogout() {
    try {
      this.$axios.setHeader("Authorization", "");
      await this.$store.dispatch("user/logout", { store: this.$store });
      redirectPage(`/auth/login`);
    } catch (error) {
      console.log("error :>> ", error);
    }
  }
  updateScreenWidth() {
    this.screenWidth = window.innerWidth;
  }

  toggleSideBar() {
    this.drawer = !this.drawer;
  }

  @Watch("screenWidth")
  closeSideBarMb(value: number) {
    if (value < 640) {
      this.drawer = false;
    }
  }
}
</script>

<style>
.logo-name {
  background: -webkit-linear-gradient(to right, #4745a1, #ae2cf1);
  background: linear-gradient(to right, #4745a1, #ae2cf1);
  -webkit-background-clip: text;
  background-clip: text;
  -webkit-text-fill-color: transparent;
  color: transparent;
  text-wrap: nowrap;
  font-weight: 800;
  font-size: 1.25rem;
}
</style>
